## opencpn 5.8.4+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      Dave Register DEB
# config from: antonm - Anton Martchukov <anton@martchukov.com>
# Update:      sethdart (Jean-Eudes Onfray)
#                 with parts from balp (Anders Arnholm)
# ***************************************************************************
# - Copyright (C) 2010 by David S. Register                               *
# - This program is free software; you can redistribute it and/or modify  *
# - it under the terms of the GNU General Public License as published by  *
# - the Free Software Foundation; either version 2 of the License, or     *
# - (at your option) any later version.                                   *
# - *
# - This program is distributed in the hope that it will be useful,       *
# - but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# - GNU General Public License for more details.                          *
# - *
# - You should have received a copy of the GNU General Public License     *
# - along with this program; if not, write to the                         *
# - Free Software Foundation, Inc.,                                       *
# - 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.         *
# ***************************************************************************

#[[
TODO:
- Profiling opt
- test with Win & OSX
USE_GLU_TESS
USE_GLU_DLL
I also find it deficient in some areas. For instance, I cannot make it
output a VS project with certain compile switches set as desired,
namely /MT vs /MD. This means I must manually set this and other compiler
options after the CMake step. Sometimes I forget. Grrr...
set /MT for Release build, and /MTd for debug.
Is this still problem? If so, generator expressions seem to be the solution.
#]]

cmake_minimum_required(VERSION 3.1.1)
cmake_policy(SET CMP0043 NEW)
cmake_policy(SET CMP0025 NEW)
if (POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)
endif ()
if (POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif ()

# Prefer libGL.so to libOpenGL.so, see CMP0072
set(OpenGL_GL_PREFERENCE "LEGACY")

if (APPLE)
  set(PACKAGE_NAME OpenCPN)
else (APPLE)
  set(PACKAGE_NAME opencpn)
endif (APPLE)

add_definitions("-DRAPIDJSON_HAS_STDSTRING=1")

if ("${OCPN_TARGET_TUPLE}" MATCHES "Android")
  message(STATUS "Building for wxQt-Android")
  set( CMAKE_TOOLCHAIN_FILE buildandroid/build_android.cmake)
  set(QT_ANDROID "ON")
  if ("${OCPN_TARGET_TUPLE}" MATCHES "Android-arm64")
    add_definitions("-DANDROID_ARM64")
  else ()
    add_definitions("-DANDROID_ARMHF")
  endif ()
  set(PACKAGE_NAME gorp)
endif ()


project(OpenCPN)

# Capture $DEB_VERSION on PPA build
if (DEFINED DEB_VERSION)
  add_definitions("-DDEB_VERSION=${DEB_VERSION}")
endif (DEFINED DEB_VERSION)

if (NOT DEFINED OCPN_VERBOSE OR OCPN_VERBOSE)
  set(CMAKE_VERBOSE_MAKEFILE ON)
endif ()

message(STATUS "cmake version: ${CMAKE_VERSION}")

# Locations where cmake looks for cmake modules.
set(
  CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/build
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/cmake
)

set(CMAKE_CXX_VISIBILITY_PRESET=hidden)

include(FindPkgConfig)
include(CMakeDependentOption)
include(CheckSymbolExists)

if (QT_ANDROID)
  #include(libs/AndroidLibs.cmake)
endif ()

#
# Options
#

macro (BUNDLE_DOCS_OPT onoff)
  option(OCPN_BUNDLE_DOCS "Include documentation in package" ${onoff})
endmacro (BUNDLE_DOCS_OPT)

macro (BUNDLE_TCDATA_OPT onoff)
  option(
    OCPN_BUNDLE_TCDATA "Include tide/current harmonics data in package"
    ${onoff}
  )
endmacro (BUNDLE_TCDATA_OPT)

macro (BUNDLE_GSHHS_OPT onoff)
    option(OCPN_BUNDLE_GSHHS "Bundle minimal GSHHS data files" ${onoff})
endmacro (BUNDLE_GSHHS_OPT)

# If on Windows or Apple, build the monolithic package, to override use a non-
# sense values from the commandline (due to cmake inability to distinguish
# between not set and set to FALSE): cmake -DOCPN_BUNDLE_DOCS=BLAH
# -DOCPN_BUNDLE_TCDATA=BLAH

# Bundle tcdata and gshhs by default also on linux, to keep the defaults
# close to the official Debian package.
bundle_gshhs_opt("ON")
bundle_tcdata_opt("ON")

if (APPLE OR WIN32)
  bundle_docs_opt("ON")
else (APPLE OR WIN32)
  bundle_docs_opt("OFF")
endif (APPLE OR WIN32)


option(OCPN_VERBOSE "Make verbose builds"  ON)
option(OCPN_PEDANTIC "Enable more compiler warnings" OFF)

set(OCPN_PACKAGE_RELEASE "1" CACHE STRING "Package release number")

option(OCPN_USE_GL "Enable OpenGL support" ON)
option(OCPN_USE_GLES_SHIM "Enable GLESv1 Shim library" OFF)
option(OCPN_USE_UDEV_PORTS "Use udev to enumerate serial ports" ON)
option(OCPN_USE_SYSFS_PORTS "Use sysfs to enumerate serial ports" OFF)

set(OCPN_TARGET_TUPLE "" CACHE STRING
  "List of target;version;arch like flatpak;20.08;aarch64 [\"\"]"
)

if (MSVC OR MINGW)
  option(OCPN_USE_CRASHREPORT "Enable crash reporting" ON)
else ()
  set(OCPN_USE_CRASHREPORT FALSE)
endif ()

if (NOT WIN32 AND NOT APPLE AND NOT QT_ANDROID)
  find_library(GTK2U NAMES wx_gtk2u_core)
  if (GTK2U)
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [OFF]" "OFF")
  else ()
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [ON]" "ON")
  endif ()
endif ()

if (WIN32 OR APPLE OR QT_ANDROID)
  set(PA_DEFAULT "OFF")
else ()
  set(PA_DEFAULT "ON")
endif ()
option(
  OCPN_ENABLE_PORTAUDIO "Use portaudio(3) to play sounds if available"
  ${PA_DEFAULT}
)
cmake_dependent_option(
  OCPN_ENABLE_SNDFILE "Use libsndfile for portaudio if available."
  ON "OCPN_ENABLE_PORTAUDIO" ON
)

option(OCPN_USE_GARMINHOST "Enable Garmin Host Mode support" ON)

if (QT_ANDROID OR ${CMAKE_VERSION} VERSION_LESS 3.14)
  set(OCPN_BUILD_TEST OFF)
else ()
  option(OCPN_BUILD_TEST "Enable test subproject build" ON)
endif ()

execute_process(
  COMMAND "ip" "address" "show" "vcan0"
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  OUTPUT_VARIABLE _VCAN_STDOUT
  RESULT_VARIABLE _VCAN_RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if ("${_VCAN_RESULT}" EQUAL 0)
  set(ENABLE_VCAN_TESTS ON)
  message(STATUS "tests using vcan0 are available.")
else ()
  set(ENABLE_VCAN_TESTS OFF)
  message(STATUS "tests using vcan0 are NOT available: \"${_VCAN_STDERR}\"")
endif ()

set(
  OCPN_WXWIDGETS_FORCE_VERSION
  CACHE STRING "Force usage of a specific wxWidgets version."
)

set(
  OCPN_WXWIDGETS_OPTIONS
  CACHE STRING "Additional flags to wxWidgets_CONFIG_OPTIONS"
)

if (WIN32 AND NOT UNIX)
  option(OCPN_BUNDLE_WXDLLS "Bundle the prebuilt WX DLLs" ON)
  option(OCPN_BUNDLE_VCDLLS "Bundle the VC redistributable libraries" ON)
  option(
    BUNDLE_LIBARCHIVEDLLS "Bundle the prebuilt LibArchive and LibLZMA DLLs" ON
  )
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  option(OCPN_ENABLE_CLANG_TIDY "Add clang-tidy automatically to builds" OFF)
  set(ENABLE_SANITIZER "none" CACHE STRING "Add clang sanitizer to the build")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.9)
  option(OCPN_ENABLE_CPPCHECK "Add cppcheck automatically to builds" OFF)
endif ()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE RelWithDebInfo
    CACHE
      STRING
      "Choose type of build: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE
  )
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

if (APPLE)
  option(OCPN_USE_LIBCPP "Use libc++ instead of libstdc++ on macOS" ON)
endif ()

option(OCPN_USE_EXTERN_CURL "Use external libcurl" OFF)

if (NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX ${TENTATIVE_PREFIX})
endif (NOT CMAKE_INSTALL_PREFIX)

if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(BUNDLED_LIBS_DEFAULT "ON")
else ()
  set(BUNDLED_LIBS_DEFAULT "OFF")
endif ()
set(OCPN_USE_BUNDLED_LIBS ${BUNDLED_LIBS_DEFAULT} CACHE STRING
  "Use bundled libraries instead of system's [ON, OFF or comma-sep list]"
)
set(OCPN_RELEASE "" CACHE STRING
  "Hardcoded value for build number when using OCPN_CI_BUILD"
)
option(OCPN_USE_NEWSERIAL "Use new serial communication implementation" ON)
option(OCPN_USE_CURL "Use Curl libraries" ON)
option(OCPN_USE_SVG "Use SVG graphics via wxSVG or wxBitmapBundle" ON)
option(OCPN_USE_WEBVIEW "Use wxWidget's webview addon if available" ON)
option(OCPN_USE_LZMA "Use LZMA for chart compression" ON)
option(OCPN_CI_BUILD "Use CI build versioning rules" OFF)
option(OCPN_USE_SYSTEM_LIBARCHIVE
  "Use the libarchive version provided by the system on MacOS" ON
)

add_definitions(-D__OCPN_USE_GLEW__)

if (WIN32)
  set(cmd_snd_default OFF)
else ()
  set(cmd_snd_default ON)
endif ()

option(
  OCPN_ENABLE_SYSTEM_CMD_SOUND
  "Use aplay(1), afplay(1) etc. to play sounds if available" ${cmd_snd_default}
)
set(OCPN_SOUND_CMD "" CACHE STRING
  "Hardcoded value for CLI command used in SystemCmdSound backend"
)

if (UNIX AND NOT APPLE AND NOT QT_ANDRIOD)
  set(LINUX "1")
endif ()

if (QT_ANDROID)
  set(OCPN_NEW_SERIAL OFF)
  set(OCPN_USE_NEWSERIAL OFF)
  set(OCPN_USE_CURL ON)
  set(OCPN_USE_LZMA OFF)
endif (QT_ANDROID)

# Check if a given library should use the bundled source
macro (USE_BUNDLED_LIB _result library)
  if ("${OCPN_USE_BUNDLED_LIBS}" STREQUAL "")
    set(OCPN_USE_BUNDLED_LIBS "ON")
  endif ()
  if (${OCPN_USE_BUNDLED_LIBS} STREQUAL "OFF")
    set(${_result} "OFF")
  elseif (${OCPN_USE_BUNDLED_LIBS} STREQUAL "ON")
    set(${_result} "ON")
  elseif (",${OCPN_USE_BUNDLED_LIBS}," MATCHES ",${library},")
    set(${_result} "ON")
  else ()
    set(${_result} "OFF")
  endif ()
endmacro (USE_BUNDLED_LIB)

#
# Language, compiler and static checkers setup
#

include(GetArch)
getarch()
message(STATUS "*** Host Build Architecture is ${ARCH}")

set(CMAKE_CXX_STANDARD 14)
message(STATUS "Setting C++11 standard via cmake standard mechanism")
if (NOT MSVC)
  set(OBJ_VISIBILITY "-fvisibility=hidden")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  if (OCPN_ENABLE_CLANG_TIDY)
    find_program(
      CLANG_TIDY_EXE
      NAMES "clang-tidy"
      PATHS /usr/local/opt/llvm/bin
    )
    if (CLANG_TIDY_EXE)
      message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
      # For more, see http://clang.llvm.org/extra/clang-tidy/
      # set(CLANG_TIDY_CHECKS "-*,modernize-*")
      set(CLANG_TIDY_CHECKS "-*,performance-*")
      set(
        CMAKE_CXX_CLANG_TIDY
        "${CLANG_TIDY_EXE};-checks=${CLANG_TIDY_CHECKS};-header-filter='${CMAKE_SOURCE_DIR}/*'"
        CACHE STRING ""
        FORCE
      )
    else ()
      message(AUTHOR_WARNING "clang-tidy not found!")
      set(CMAKE_CXX_CLANG_TIDY "" CACHE STRING "" FORCE) # delete it
    endif ()
  endif ()
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  # Add support for address etc sanitizers, part 1/2 (other half after
  # ADD_EXECUTABLE)
  set_property(
    CACHE ENABLE_SANITIZER
    PROPERTY STRINGS none address memory thread undefined
  )
  if (NOT "${ENABLE_SANITIZER}" MATCHES "none")
    add_compile_options(-fsanitize=${ENABLE_SANITIZER})
  endif ()
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.9)
  if (OCPN_ENABLE_CPPCHECK)
    find_program(CPPCHECK_EXECUTABLE NAMES "cppcheck")
    set(CMAKE_CXX_CPPCHECK ${CPPCHECK_EXECUTABLE})
  endif ()
endif ()

message(STATUS "Default compiler options:")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
message(STATUS "CMAKE_CXX_FLAGS_DEBUG: ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "CMAKE_CXX_FLAGS_MINSIZEREL: ${CMAKE_CXX_FLAGS_MINSIZEREL}")
message(STATUS "CMAKE_CXX_FLAGS_RELEASE: ${CMAKE_CXX_FLAGS_RELEASE}")
message(
  STATUS "CMAKE_CXX_FLAGS_RELWITHDEBINFO: ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}"
)

# ADD_COMPILE_OPTIONS( "-Wall" "-ansi" "-pedantic" "-Wno-variadic-macros" )
# TODO: Should we use  -fno-stack-protector IF NOT DEBUGGING CFLAGS="-O2
# -march=native"
if (NOT WIN32 AND NOT APPLE)
  add_compile_options("-Wall")
  if (NOT OCPN_PEDANTIC)
    add_compile_options(
      "-Wno-unused"
      "-fexceptions"
      "-rdynamic"

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(opencpn_tests)
set(CMAKE_CXX_STANDARD 14)
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
message(STATUS "Building tests")


enable_testing ()

set(PROJ_SRC ${PROJECT_SOURCE_DIR}/../src)

set(SRC
  tests.cpp
  ${MODEL_SRC}
  ${CMAKE_SOURCE_DIR}/src/api_shim.cpp
  ${CMAKE_SOURCE_DIR}/src/base_platform.cpp
)
if (LINUX)
  list(APPEND SRC n2k_tests.cpp)
endif ()

add_executable(tests ${SRC})

target_compile_definitions(tests PUBLIC CLIAPP USE_MOCK_DEFS)
if (MSVC)
  target_link_libraries(tests PRIVATE setupapi.lib psapi.lib)
endif ()
target_include_directories(
  tests
  PRIVATE
  ${PROJECT_SOURCE_DIR}/../include
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/../libs/sound/include
  ${PROJECT_SOURCE_DIR}/../libs/sound/include
  ${PROJECT_SOURCE_DIR}/../buildandroid/libcurl/include
)

if (CMAKE_VERSION VERSION_GREATER 3.4)
  if (NOT "${ENABLE_SANITIZER}" MATCHES "none")
    target_link_libraries(tests
        PRIVATE -fsanitize=${ENABLE_SANITIZER}
    )
  endif ()
endif ()

target_link_libraries(tests PRIVATE ${wxWidgets_LIBRARIES})
if (DEFINED LIBELF_LIBRARY)
  target_link_libraries(tests PRIVATE "${LIBELF_LIBRARY}")
endif ()

target_link_libraries(tests PRIVATE observable::observable)
target_link_libraries(tests PRIVATE ocpn::easywsclient)
target_link_libraries(tests PRIVATE ocpn::garminhost)
target_link_libraries(tests PRIVATE ocpn::gdal)
target_link_libraries(tests PRIVATE ocpn::geoprim)
target_link_libraries(tests PRIVATE ocpn::iso8211)
target_link_libraries(tests PRIVATE ocpn::libarchive)
target_link_libraries(tests PRIVATE ocpn::mongoose)
target_link_libraries(tests PRIVATE ocpn::N2KParser)
target_link_libraries(tests PRIVATE ocpn::nmea0183)
target_link_libraries(tests PRIVATE ocpn::pugixml)
target_link_libraries(tests PRIVATE ocpn::rapidjson)
target_link_libraries(tests PRIVATE ocpn::s52plib)
target_link_libraries(tests PRIVATE ocpn::serial)
target_link_libraries(tests PRIVATE ocpn::tinyxml)
target_link_libraries(tests PRIVATE ocpn::wxjson)

if (DEFINED CURL_LIBRARIES)
  target_link_libraries(tests PRIVATE ${CURL_LIBRARIES})
endif ()
if (DEFINED WXCURL_LIBRARIES)
  target_link_libraries(tests PRIVATE ${WXCURL_LIBRARIES})
elseif (DEFINED WXSYS_CURL_LIBRARIES)
  target_link_libraries(tests PRIVATE ${SYS_WXCURL_LIBRARIES})
elseif (TARGET ocpn::wxcurl)
  target_link_libraries(tests PRIVATE ocpn::wxcurl)
endif ()

if (DEFINED LIBELF_LIBRARY)
  target_link_libraries(tests PRIVATE ${LIBELF_LIBRARY})
endif ()
if (HAVE_LIBUDEV)
  target_link_libraries(tests PRIVATE ocpn::libudev)
endif ()
if (LIBLZMA_FOUND)
  if (TARGET LibLZMA::LibLZMA)
    target_link_libraries(tests PRIVATE LibLZMA::LibLZMA)
  else ()
    target_link_libraries(tests PRIVATE ${LIBLZMA_LIBRARIES})
  endif ()
endif ()

if (NOT WIN32)
  find_package(OpenSSL)
  if (OPENSSL_FOUND)
    message(STATUS "OpenSSL found   ${OPENSSL_INCLUDE_DIR} ${OPENSSL_LIBRARIES}")
    target_include_directories(tests PRIVATE ${OPENSSL_INCLUDE_DIR})
    target_link_libraries(tests PRIVATE ${OPENSSL_LIBRARIES})
    add_definitions(-DMG_ENABLE_OPENSSL)
  endif (OPENSSL_FOUND)
else (NOT WIN32)
    target_include_directories(
      tests
      PRIVATE ${CMAKE_SOURCE_DIR}/cache/buildwin/include/openssl
    )
    target_link_libraries(
      tests
      PRIVATE ${CMAKE_SOURCE_DIR}/cache/buildwin/libssl.lib
    )
   target_link_libraries(
      tests
      PRIVATE ${CMAKE_SOURCE_DIR}/cache/buildwin/libcrypto.lib
    )
endif (NOT WIN32)


target_link_libraries(tests PRIVATE ocpn::gtest)
include(GoogleTest)
gtest_discover_tests(tests)


add_test(NAME tests COMMAND tests)

=== libs/N2KParser/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::N2KParser)
    return ()
endif ()

set (SRC
  src/N2KParser.cpp
  include/N2KParser.h
  src/N2kMessages.cpp
  src/N2kMsg.cpp
)
add_library(N2KPARSER STATIC ${SRC})
add_library(ocpn::N2KParser ALIAS N2KPARSER)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
  target_compile_options(
    N2KPARSER PRIVATE
      -fvisibility=default -Wno-unknown-pragmas -fPIC
  )
endif ()
target_include_directories(
  N2KPARSER PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
)

=== libs/SQLiteCpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
# SQLite3 support required for MBTiles.

if (TARGET ocpn::sqlite_cpp)
    return ()
endif ()

set(SRC
    src/Backup.cpp
    src/Column.cpp
    src/Database.cpp
    src/Exception.cpp
    src/Statement.cpp
    src/Transaction.cpp
)
set(INCL
    include/SQLiteCpp/SQLiteCpp.h
    include/SQLiteCpp/Assertion.h
    include/SQLiteCpp/Backup.h
    include/SQLiteCpp/Column.h
    include/SQLiteCpp/Database.h
    include/SQLiteCpp/Exception.h
    include/SQLiteCpp/Statement.h
    include/SQLiteCpp/Transaction.h
    include/SQLiteCpp/Utils.h
    include/SQLiteCpp/VariadicBind.h
)
add_library(SQLITE_CPP STATIC ${SRC} ${INCL})
add_library(ocpn::sqlite_cpp ALIAS SQLITE_CPP)

target_link_libraries(SQLITE_CPP PRIVATE ocpn::sqlite)

target_include_directories(SQLITE_CPP
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/sqlite3
    PUBLIC  ${CMAKE_CURRENT_SOURCE_DIR}/include
)
set_property(TARGET SQLITE_CPP PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")

# We do not need extensions, and using them in a static library causes trouble with libdl linking order.
if (UNIX AND NOT APPLE)
    add_definitions(" -DSQLITE_OMIT_LOAD_EXTENSION")
endif (UNIX AND NOT APPLE)

=== libs/easywsclient/Makefile ===
CXXFLAGS = -std=gnu++0x -Wall
LDLIBS = -lstdc++
.PHONY: all clean test
all: example-client example-client-cpp11
clean:
	-rm  example-client example-client-cpp11 *.o
	cd test; $(MAKE) clean
test:
	cd test; $(MAKE) test
testserver: node_modules
	node example-server.js
node_modules:
	npm install
example-client-cpp11: example-client-cpp11.o easywsclient.o
example-client-cpp11.o: example-client-cpp11.cpp easywsclient.hpp
example-client: example-client.o easywsclient.o
example-client.o: example-client.cpp easywsclient.hpp
easywsclient.o: easywsclient.cpp easywsclient.hpp

=== libs/garmin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (TARGET ocpn::garminhost)
    return ()
endif ()

# Build the garmin lib, once upon a time copied from gpslib. Needs
# a -DwxWidgets_INCLUDE_DIRS if built  separately.

set( SRC
    jeeps/gpsapp.c
    jeeps/gpscom.c
    jeeps/gpsmath.c
    jeeps/gpsmem.c
    jeeps/gpsprot.c
    jeeps/gpsread.c
    jeeps/gpsdevice.c
    jeeps/gpsdevice_ser.c
    jeeps/gpsdevice_usb.c
    jeeps/gpsrqst.c
    jeeps/gpssend.c
    jeeps/gpsserial.c
    jeeps/gpsutil.c
    jeeps/gpsusbread.c
    jeeps/gpsusbsend.c
    jeeps/gpsusbcommon.c
    jeeps/garmin_gps.h
    jeeps/gpsapp.h
    jeeps/gpsdatum.h
    jeeps/gpsfmt.h
    jeeps/gpsmath.h
    jeeps/gpsport.h
    jeeps/gpsprot.h
    jeeps/gpsrqst.h
    jeeps/gpsserial.h
    jeeps/gpsusbint.h
    jeeps/gps_wx_logging.h
    jeeps/garminusb.h
    jeeps/gpscom.h
    jeeps/gpsdevice.h
    jeeps/gpsinput.h
    jeeps/gpsmem.h
    jeeps/gpsproj.h
    jeeps/gpsread.h
    jeeps/gpssend.h
    jeeps/gpsusbcommon.h
    jeeps/gpsutil.h
    jeeps/garmin_wrapper_utils.h
    jeeps/garmin_wrapper_utils.c
)
if (WIN32)
  set(SRC ${SRC} jeeps/gpsusbwin.c)
  add_definitions(-D__WIN32__)
endif ()
set_source_files_properties(${SRC} PROPERTIES LANGUAGE CXX )

add_library(GARMINHOST STATIC ${SRC})
add_library(ocpn::garminhost ALIAS GARMINHOST)
if (MINGW)
  target_compile_definitions(GARMINHOST PRIVATE "-D_UNICODE")
endif ()

target_compile_definitions(GARMINHOST PRIVATE "-DUSE_WX_LOGGING")
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
  target_compile_options(GARMINHOST PRIVATE -fvisibility=default -fPIC)
endif ()
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  target_compile_options(GARMINHOST PRIVATE -x c++)
endif ()

target_include_directories(GARMINHOST PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/jeeps)
target_include_directories(GARMINHOST PRIVATE ${wxWidgets_INCLUDE_DIRS})

=== libs/geoprim/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::geoprim)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

SET(SRC
    src/bbox.cpp
    src/bbox.h
    src/LLRegion.cpp
    src/LLRegion.h
    src/line_clip.cpp
    src/line_clip.h
    src/poly_math.cpp
    src/poly_math.h
    src/LOD_reduce.cpp
    src/LOD_reduce.h
    src/linmath.h
    )

if (NOT wxWidgets_INCLUDE_DIRS)
    include(SimpleWxConfig)
    SimpleWxConfig()
endif ()

add_library(GEOPRIM STATIC ${SRC})
add_library(ocpn::geoprim ALIAS GEOPRIM)

set_property(TARGET GEOPRIM PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(GEOPRIM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/src)
target_include_directories(GEOPRIM PRIVATE ${wxWidgets_INCLUDE_DIRS})
target_include_directories(GEOPRIM PRIVATE ../../include)

find_package(OpenGL)
if (OPENGL_FOUND)
    target_include_directories(GEOPRIM PRIVATE ${OPENGL_INCLUDE_DIR})

    message(STATUS "Found OpenGL....")
    message(STATUS "    GL Lib: " ${OPENGL_LIBRARIES})
    message(STATUS "    GL Include: " ${OPENGL_INCLUDE_DIR})

    target_link_libraries(GEOPRIM PRIVATE ${OPENGL_LIBRARIES} )
endif (OPENGL_FOUND)

=== libs/glshim/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(glesgl)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

# Raspberry PI
if(BCMHOST)
    include_directories(/opt/vc/include /opt/vc/include/interface/vcos/pthreads /opt/vc/include/interface/vmcs_host/linux)
    link_directories(/opt/vc/lib)
    add_definitions(-DBCMHOST)
endif()

link_directories(${CMAKE_BINARY_DIR}/lib)
add_definitions(-g -std=c99 -funwind-tables -O2)

include_directories(include)
add_subdirectory(src)

=== libs/gtest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if (TARGET ocpn::gtest)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

add_library(_OCPN_GTEST_IF INTERFACE)
add_library(ocpn::gtest ALIAS _OCPN_GTEST_IF)

find_library(GTEST_LIB gtest)
find_library(GTEST_MAIN gtest_main)
find_path(GTEST_HDR NAME gtest PATH_SUFFIXES gtest)

if (GTEST_LIB AND GTEST_MAIN AND GTEST_HDR)
  message(STATUS "Using system gtest libraries")
  target_include_directories(_OCPN_GTEST_IF INTERFACE ${GTEST_HDR})
  target_link_libraries(_OCPN_GTEST_IF INTERFACE ${GTEST_LIB})
  target_link_libraries(_OCPN_GTEST_IF INTERFACE ${GTEST_MAIN})
else ()
  find_path(GTEST_SRC_LOCATION
    NAMES googlemock/src/gmock-all.cc googletest/src/gtest-all.cc
    HINTS ENV GTEST_SRC_ROOT
    PATHS "/usr/src/googletest"
    NO_DEFAULT_PATH
  )
  include(FetchContent)
  set(CMAKE_CXX_STANDARD 14)
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  set(BUILD_GMOCK OFF)
  set(INSTALL_GTEST OFF)
  if (GTEST_SRC_LOCATION)
    message(STATUS "Building gtest from installed sources")
    add_subdirectory(${GTEST_SRC_LOCATION} ${CMAKE_BINARY_DIR}/gtest)
  else ()
    message(STATUS "Downloading and building gtest from source")
    FetchContent_Declare(
      googletest
      GIT_REPOSITORY https://github.com/google/googletest.git
      GIT_TAG release-1.12.1
    )
    FetchContent_MakeAvailable(googletest)
  endif ()
  target_link_libraries(_OCPN_GTEST_IF INTERFACE GTest::gtest_main)
endif ()

=== libs/iso8211/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::iso8211)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

SET(SRC
    include/iso8211.h
    src/ddffield.cpp
    src/ddffielddefn.cpp
    src/ddfmodule.cpp
    src/ddfrecord.cpp
    src/ddfrecordindex.cpp
    src/ddfsubfielddefn.cpp
    src/ddfutils.cpp
)

add_library(ISO8211 STATIC ${SRC})
add_library(ocpn::iso8211 ALIAS ISO8211)
set_property(TARGET ISO8211 PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(ISO8211 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_include_directories(ISO8211 PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../../include)
target_include_directories(ISO8211 PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../gdal/include)

=== libs/mDNS/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::mDNS)
    return ()
endif ()

set (SRC
  src/mdns_util.cpp
  include/mdns_util.h
  include/mdns.h
)
add_library(MDNS STATIC ${SRC})
target_include_directories(MDNS PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
set_property(TARGET MDNS PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
add_library(ocpn::mDNS ALIAS MDNS)

=== libs/mipmap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::mipmap)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

include(GetArch)
GetArch()

include(CompilerSupport)

set(SRC
  include/mipmap/mipmap.h
  src/mipmap.c
)

if( NOT QT_ANDROID)
    set(SRC_IPML
        src/mipmap_sse.c
        src/mipmap_sse2.c
        src/mipmap_ssse3.c
        src/mipmap_avx2.c
        src/mipmap_neon.c
    )
endif( NOT QT_ANDROID)

add_library(MIPMAP STATIC ${SRC} ${SRC_IPML})
add_library(ocpn::mipmap ALIAS MIPMAP)
target_include_directories(MIPMAP
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include/mipmap
)

if( NOT QT_ANDROID)
  # always use optimizations for the texture compression which is much faster
  if (NOT MSVC)
      set_property(TARGET MIPMAP PROPERTY COMPILE_FLAGS "-fvisibility=hidden -O3")
      if (HAVE_MSSE)
          set_source_files_properties(
              src/mipmap_sse.c PROPERTIES COMPILE_FLAGS "-msse")
      endif ()
      if (HAVE_MSSE2)
          set_source_files_properties(
              src/mipmap_sse2.c PROPERTIES COMPILE_FLAGS "-msse2")
      endif ()
      if (HAVE_MSSE3)
          set_source_files_properties(
              src/mipmap_ssse3.c PROPERTIES COMPILE_FLAGS "-mssse3")
      endif ()
      if (HAVE_MAVX2)
          set_source_files_properties(
              src/mipmap_avx2.c PROPERTIES COMPILE_FLAGS "-mavx2")
      endif ()
      if (HAVE_MFPU_NEON)
          set_source_files_properties(
              src/mipmap_neon.c PROPERTIES COMPILE_FLAGS "-mfpu=neon")
      endif ()
  else (NOT MSVC)
      # try to use sse on x86 based systems
      if (ARCH MATCHES "i386" OR ARCH MATCHES "amd64" OR ARCH MATCHES "x86_64")
          set_source_files_properties(
              src/mipmap_sse.c PROPERTIES COMPILE_FLAGS "/arch:SSE")
          set_source_files_properties(
              src/mipmap_sse2.c PROPERTIES COMPILE_FLAGS "/arch:SSE2")
          set_source_files_properties(
              src/mipmap_avx2.c PROPERTIES COMPILE_FLAGS "/arch:AVX")
      endif ()
  endif (NOT MSVC)
else (NOT QT_ANDROID)
  set_source_files_properties(
      src/mipmap/mipmap_neon.c
      PROPERTIES COMPILE_FLAGS "-mfloat-abi=softfp -mfpu=neon")
endif (NOT QT_ANDROID)

=== debian/changelog ===
opencpn (5.8.4+dfsg-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:10:24 +1100

opencpn (5.8.4+dfsg-1build3) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:14:13 +0000

opencpn (5.8.4+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:29:30 +0000

opencpn (5.8.4+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 01:02:57 +0000

opencpn (5.8.4+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 15 Jun 2023 20:26:20 +0200

=== debian/control ===
Source: opencpn
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alec Leamas <leamas.alec@gmail.com>
Section: misc
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 googletest,
 libarchive-dev,
 libbz2-dev,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libcxx-serial-dev,
 libdrm-dev,
 libelf-dev,
 libexif-dev,
 libgdk-pixbuf-2.0-dev,
 libglew-dev,
 libgtk-3-dev,
 libjs-highlight.js,
 libjs-mathjax,
 liblz4-dev,
 liblzma-dev,
 libpango1.0-dev,
 libsqlite3-dev,
 libssl-dev,
 libtinyxml-dev,
 libudev-dev,
 libunarr-dev,
 libusb-1.0-0-dev,
 libwxsvg-dev (>= 2:1.5.21),
 libwxgtk3.2-dev | libwxgtk3.0-gtk3-dev,
 libwxgtk-webview3.2-dev | libwxgtk-webview3.0-gtk3-dev,
 lsb-release,
 portaudio19-dev,
 rapidjson-dev
Standards-Version: 4.6.2
Vcs-Browser: https://gitlab.com/leamas/opencpn
Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/sid
Homepage: https://opencpn.org
Rules-Requires-Root: no

Package: opencpn
Architecture: any
Depends: opencpn-data (>= ${source:Version}),
 bzip2,
 libjs-mathjax,
 libjs-highlight.js,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: wx3.0-i18n
Breaks: opencpn-plugins (<< 4.8.8~)
Replaces: opencpn-plugins (<< 4.8.8~)
Suggests: binutils
Description: Open Source Chartplotter and Marine GPS Navigation Software
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains programs, libraries and some support files.

Package: opencpn-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Open Source Chartplotter and Marine GPS Navigation Software (data)
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains architecture independent data files.

=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo \
            -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
            -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
            -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=ON \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
            -DOCPN_FORCE_GTK3=ON

override_dh_auto_test:
	cd obj-*-linux-gnu*; make run-tests
